<!DOCTYPE html>
<html lang="en">

<head>
    <title>Index page</title>
    <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css">
</head>

<body>
    <div class="container">
        <h2 align="center" class="text-danger">Closures in JavaScript</h2>
        <hr />

        <!-- Javascript closures tutorial -->
		<div id="title">
			<h4 class="text-info">What is a Closure?</h4>
			<ul>
				<li>It is an inner function that has access to outer function's variables and parameters in addition to it's own and global variables.</li>
				<li>Users can create a closure by defining a function inside another function.</li>
				<li>The scope of the closure is defined statically by its location within the source code.</li>
				<li>Usage:
						<ul>
							<li>Maintain a private reference to a variable in the outer scope.</li>
						</ul>
				</li>
			</ul>
		</div>
		<div>&nbsp;</div>
		
		<button id="btn_submit" type="button" class="btn btn-success" onclick="clicks();">Click me</button>
		<div>&nbsp;</div>
		
		<div id="result"></div>
    </div>
    <script>
		var clicks = (function () 
		{
			var count = 0;
			return function() {
				document.getElementById("result").innerHTML = ++count;
			}
		})();
    </script>
</body>

</html>